﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace Trolleybus
{
    internal static class ExtentionTrolleybus
    {
        private static readonly char _separatorForObject = ':';
        public static DrawingTrolleybus CreateDrawingTrolleybus(this string info)
        {
            string[] strs = info.Split(_separatorForObject);
            if (strs.Length == 3)
            {
                return new DrawingTrolleybus(Convert.ToInt32(strs[0]),
                    Convert.ToInt32(strs[1]), Color.FromName(strs[2]));
            }
            if (strs.Length == 7)
            {
                return new DrawningSmallTrolleybus(Convert.ToInt32(strs[0]),
                    Convert.ToInt32(strs[1]), Color.FromName(strs[2]),
                    Color.FromName(strs[3]), Convert.ToBoolean(strs[4]),
                    Convert.ToBoolean(strs[5]), Convert.ToBoolean(strs[6]));
            }
            return null;
        }

        public static string GetDataForSave(this DrawingTrolleybus drawningTrolleybus)
        {
            var trolleybus = drawningTrolleybus.Trolleybus;
            var str = $"{trolleybus.Speed}{_separatorForObject}{trolleybus.Weight}{_separatorForObject}{trolleybus.BodyColor.Name}";
            if (trolleybus is not EntitySmallTrolleybus smallTrolleybus)
            {
                return str;
            }
            return $"{str}{_separatorForObject}{smallTrolleybus.DopColor.Name}{_separatorForObject}{smallTrolleybus.BodyKit}{_separatorForObject}{smallTrolleybus.Horns}{_separatorForObject}{smallTrolleybus.Battary}";
        }
    }
}
