﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Trolleybus
{
    public partial class Form1 : Form
    {
        private DrawingTrolleybus _trolleybus;
        public DrawingTrolleybus SelectedTrolleybus { get; private set; }
        public Form1()
        {
            InitializeComponent();
        }
        /// <summary>
        /// Метод прорисовки троллейбуса 
        /// </summary>

        private void Draw()
        {
            Bitmap bmp = new Bitmap(pictureBoxTrolleybus.Width, pictureBoxTrolleybus.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _trolleybus?.DrawTransport(gr);
            pictureBoxTrolleybus.Image = bmp;
        }

        private void SetData()
        {
            Random rnd = new Random();
            _trolleybus.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), pictureBoxTrolleybus.Width, pictureBoxTrolleybus.Height);
            toolStripStatusLabelSpeed.Text = $"Скорость: {_trolleybus.Trolleybus.Speed}";
            toolStripStatusLabelWeight.Text = $"Вес: {_trolleybus.Trolleybus.Weight}";
            toolStripStatusLabelBodyColor.Text = $"Цвет: {_trolleybus.Trolleybus.BodyColor.Name}";
        }

        /// <summary>
        /// Обработка нажатия "Создать"
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>

        private void buttonCreate_Click(object sender, EventArgs e)
        {
            Random random = new();
            Color myColor = new Color();
            ColorDialog MyDialog = new ColorDialog();
            if (MyDialog.ShowDialog() == DialogResult.OK)
                myColor = MyDialog.Color;
            _trolleybus = new DrawingTrolleybus(random.Next(30, 50), random.Next(1000, 2000),
                myColor);
            SetData();
            Draw();
        }

        private void ButtonMove_Click(object sender, EventArgs e)
        {
            //получаем имя кнопки
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _trolleybus?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _trolleybus?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _trolleybus?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _trolleybus?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }
        private void PictureBoxTrolleybus_Resize(object sender, EventArgs e)
        {
            _trolleybus?.ChangeBorders(pictureBoxTrolleybus.Width, pictureBoxTrolleybus.Height);
            Draw();
        }

        private void buttonCreateModif_Click(object sender, EventArgs e)
        {
            Random random = new();
            Color firstColor = new Color();
            Color secondColor = new Color();
            ColorDialog MyDialog = new ColorDialog();
            if (MyDialog.ShowDialog() == DialogResult.OK)
                firstColor = MyDialog.Color;
            MyDialog = new ColorDialog();
            if (MyDialog.ShowDialog() == DialogResult.OK)
                secondColor = MyDialog.Color;
            _trolleybus = new DrawningSmallTrolleybus(random.Next(100, 300), random.Next(1000, 2000),
                Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)));

            SetData();
            Draw();
        }

        private void buttonSelectTrolleybus_Click(object sender, EventArgs e)
        {
            SelectedTrolleybus = _trolleybus;
            DialogResult = DialogResult.OK;
        }
    }
}
