﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Trolleybus
{
    public partial class FormTrolleybusConfig : Form
    {
        DrawingTrolleybus _trolleybus = null;
        private event TrolleybusDelegate EventAddTrolleybus;
        public FormTrolleybusConfig()
        {
            InitializeComponent();
            panelBlack.MouseDown += PanelColor_MouseDown;
            panelPurple.MouseDown += PanelColor_MouseDown;
            panelGrey.MouseDown += PanelColor_MouseDown;
            panelGreen.MouseDown += PanelColor_MouseDown;
            panelRed.MouseDown += PanelColor_MouseDown;
            panelWhite.MouseDown += PanelColor_MouseDown;
            panelYellow.MouseDown += PanelColor_MouseDown;
            panelBlue.MouseDown += PanelColor_MouseDown;

            buttonCancel.Click += (object sender, EventArgs e) => Close();
        }

        private void DrawTrolleybus()
        {
            Bitmap btm = new(pictureBoxObject.Width, pictureBoxObject.Height);
            Graphics gr = Graphics.FromImage(btm);
            _trolleybus?.SetPosition(25, 25, pictureBoxObject.Width, pictureBoxObject.Height);
            _trolleybus?.DrawTransport(gr);
            pictureBoxObject.Image = btm;
        }

        public void AddEvent(TrolleybusDelegate ev)
        {
            if (EventAddTrolleybus == null)
            {
                EventAddTrolleybus = new TrolleybusDelegate(ev);
            }
            else
            {
                EventAddTrolleybus += ev;
            }
        }

        private void labelObject_Mouse_Down(object sender, MouseEventArgs e)
        {
            (sender as Label).DoDragDrop((sender as Label).Name, DragDropEffects.Move | DragDropEffects.Copy);
        }

        private void panelObject_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.Text))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        private void panelObject_DragDrop(object sender, DragEventArgs e)
        {
            //labelColor.BackColor = Color.Red;
            switch (e.Data.GetData(DataFormats.Text).ToString())
            {
                case "labelSimpleObject":
                    _trolleybus = new DrawingTrolleybus((int)numericUpDownSpeed.Value, (int)numericUpDownWeight.Value, Color.White);
                    break;
                case "labelModifiedObject":
                    _trolleybus = new DrawningSmallTrolleybus((int)numericUpDownSpeed.Value, (int)numericUpDownWeight.Value, Color.White, Color.Black,
                        checkBoxBodyKit.Checked, checkBoxHorns.Checked, checkBoxBattary.Checked);
                    break;
            }
            DrawTrolleybus();
        }
        private void PanelColor_MouseDown(object sender, MouseEventArgs e)
        {
            (sender as Control).DoDragDrop((sender as Control).BackColor, DragDropEffects.Move | DragDropEffects.Copy);
        }
        private void LabelColor_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(Color)))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        private void LabelBaseColor_DragDrop(object sender, DragEventArgs e)
        {
            //проверка на пустоту объекта
            if (_trolleybus != null)
            {
                _trolleybus.Trolleybus.BodyColor = (Color)e.Data.GetData(typeof(Color));

                DrawTrolleybus();
            }
        }

        private void LabelAddColor_DragDrop(object sender, DragEventArgs e)
        {
            //проверка на пустоту объекта и правильную сущноть
            if (_trolleybus != null && _trolleybus.Trolleybus is EntitySmallTrolleybus smallTrolleybus)
            {
                smallTrolleybus.DopColor = (Color)e.Data.GetData(typeof(Color));

                DrawTrolleybus();
            }
        }

        private void ButtonOk_Click(object sender, EventArgs e)
        {
            EventAddTrolleybus?.Invoke(_trolleybus);
            Close();
        }
    }
}
