﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Trolleybus
{
    internal class TrolleybusCompareByColor : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject? x, IDrawningObject? y)
        {
            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xTrolleybus = x as DrawningObjectTrolleybus;
            var yTrolleybus = y as DrawningObjectTrolleybus;
            if (xTrolleybus == null && yTrolleybus == null)
            {
                return 0;
            }
            if (xTrolleybus == null && yTrolleybus != null)
            {
                return 1;
            }
            if (xTrolleybus != null && yTrolleybus == null)
            {
                return -1;
            }
            var xEntityTrolleybus = xTrolleybus._trolleybus.Trolleybus;
            var yEntityTrolleybus = yTrolleybus._trolleybus.Trolleybus;
            var baseColorCompare = xEntityTrolleybus.BodyColor.ToArgb().CompareTo(yEntityTrolleybus.BodyColor.ToArgb());
            if (baseColorCompare != 0)
            {
                return baseColorCompare;
            }
            if (xEntityTrolleybus is EntitySmallTrolleybus xSmallTrolleybus && yEntityTrolleybus is EntitySmallTrolleybus ySmallTrolleybus)
            {
                var dopColorCompare = xSmallTrolleybus.DopColor.ToArgb().CompareTo(ySmallTrolleybus.DopColor.ToArgb());
                if (dopColorCompare != 0)
                {
                    return dopColorCompare;
                }
            }
            var speedCompare = xTrolleybus._trolleybus.Trolleybus.Speed.CompareTo(yTrolleybus._trolleybus.Trolleybus.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xTrolleybus._trolleybus.Trolleybus.Weight.CompareTo(yTrolleybus._trolleybus.Trolleybus.Weight);
        }
    }
}
