﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Trolleybus
{
    internal class TrolleybusCompareByType : IComparer<IDrawningObject>
    {
            public int Compare(IDrawningObject? x, IDrawningObject? y)
            {
                if (x == null && y == null)
                {
                    return 0;
                }
                if (x == null && y != null)
                {
                    return 1;
                }
                if (x != null && y == null)
                {
                    return -1;
                }
                var xTrolleybus = x as DrawningObjectTrolleybus;
                var yTrolleybus = y as DrawningObjectTrolleybus;
                if (xTrolleybus == null && yTrolleybus == null)
                {
                    return 0;
                }
                if (xTrolleybus == null && yTrolleybus != null)
                {
                    return 1;
                }
                if (xTrolleybus != null && yTrolleybus == null)
                {
                    return -1;
                }
                if (xTrolleybus.GetTrolleybus.GetType().Name != yTrolleybus.GetTrolleybus.GetType().Name)
                {
                    if (xTrolleybus.GetTrolleybus.GetType().Name == "DrawningAirplane")
                    {
                        return -1;
                    }
                    return 1;
                }
                var speedCompare = xTrolleybus.GetTrolleybus.Trolleybus.Speed.CompareTo(yTrolleybus.GetTrolleybus.Trolleybus.Speed);
                if (speedCompare != 0)
                {
                    return speedCompare;
                }
                return xTrolleybus.GetTrolleybus.Trolleybus.Weight.CompareTo(yTrolleybus.GetTrolleybus.Trolleybus.Weight);
            }
    }
}
